<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 05/28/2007 *
 * ================                             Last change: 05/31/2007 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : ext-bank.php                                     *
 * -------------------------------------------------------------------- *
 * Short description : A little bank account                            *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Ein einfaches Bankaccount                        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if (!defined('__SECURITY')) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Version number
$EXT_VERSION = "0.0";

// Auto-set extension version
if (!isset($EXT_VER)) $EXT_VER = $EXT_VERSION;

// Version history array (add more with , "0.1" and so on)
$EXT_VER_HISTORY = array("0.0");

switch ($EXT_LOAD_MODE)
{
case "register": // Do stuff when installtion is running (modules.php?module=admin&action=login is called)
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_accounts";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_bank_accounts (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
uid BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
account_created BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
account_locked BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
locked_reason TINYTEXT,
status ENUM('NEW','ACTIVE','LOCKED') NOT NULL DEFAULT 'NEW',
account_balance DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
output_mode ENUM('LOGIN','EMAIL','DISABLED'),
pin VARCHAR(50) NOT NULL DEFAULT '',
tan_mode ENUM('NORMAL','INDEXED'),
tan_list_status ENUM('PENDING','ACTIVE','INVALID','LOCKED') NOT NULL DEFAULT 'PENDING',
tan_key VARCHAR(50) NOT NULL DEFAULT '',
month_transfered BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
last_tan VARCHAR(5) NOT NULL DEFAULT '00000',
last_tan_stamp BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
last_tan_purpose TINYTEXT,
account_type ENUM('CHECK','SAVING') NOT NULL DEFAULT 'CHECK',
overdraft_credit DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
PRIMARY KEY (id),
UNIQUE KEY (pin),
INDEX `uid_type` (uid, account_type),
INDEX (account_created),
INDEX (account_locked),
INDEX (last_tan_stamp)
) TYPE=MyISAM";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_transfers";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_bank_transfers (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
to_account_id BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
from_account_id BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
points_amount DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
day_bookkeeping CHAR(4) NOT NULL DEFAULT '0000',
day_available CHAR(4) NOT NULL DEFAULT '0000',
transfer_purpose TINYTEXT,
PRIMARY KEY (id),
INDEX (to_account_id, from_account_id),
INDEX (day_bookkeeping, day_available)
) TYPE=MyISAM";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_packages";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_bank_packages (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
title VARCHAR(255) NOT NULL DEFAULT '',
description TINYTEXT,
account_fee DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
free_transfers INT(7) UNSIGNED NOT NULL DEFAULT '0',
transfer_fee DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
available TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP,
output_system_mode ENUM('LOGIN','EMAIL','DISABLED'),
package_active ENUM('Y','N') NOT NULL DEFAULT 'N',
free_months_no_fee TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
interest_plus FLOAT(7,5) UNSIGNED NOT NULL DEFAULT '0.00000',
interest_minus FLOAT(7,5) UNSIGNED NOT NULL DEFAULT '0.00000',
first_payment DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
free_account_income DOUBLE(20,5) UNSIGNED NOT NULL DEFAULT '0.00000',
free_account_stuff TINYTEXT null,
tan_lock TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
PRIMARY KEY (id)
) TYPE=MyISAM";
	// free_account_stuff will be a list of columns of the table _bank_packages
	// what the member shall get for the specified income. output_system_mode
	// must be extended with the mode you get for free: output_system_mode:LOGIN
	// should be fine. More than one entry and not DISABLED ;) are not supported.
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_tanlist";
	$SQLs[] = "CREATE TABLE "._MYSQL_PREFIX."_bank_tanlist (
id BIGINT(20) UNSIGNED NOT NULL AUTO_INCREMENT,
idx TINYINT(3) UNSIGNED NOT NULL DEFAULT '0',
account_id BIGINT(20) UNSIGNED NOT NULL DEFAULT '0',
tan VARCHAR(50) NOT NULL DEFAULT '',
used ENUM('Y','N') NOT NULL DEFAULT 'N',
PRIMARY KEY (id),
UNIQUE (account_id, tan)
) TYPE=MyISAM";

	// Admin menu queries
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank', NULL, 'Bank-Accounts','Verwalten Sie hier alle Bank-Accounts Ihrer Mitglieder, sowie Angebotspakete und &Uuml;berweisungen.', 6)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','add_bank_package','Angebotspaket hinzuf&uuml;gen','Neues Angebotspaket erstellen.', 1)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','list_bank_package','Angebotspakete auflisten','Listet alle erstellten Angebotspakete auf.', 2)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','edit_bank_package','Angebotspaket &auml;ndern','Nach Auswahl eines Angebotspaketes k&ouml;nnen Sie dieses hier ver&auml;ndern. Bitte beachten Sie, dass Ihre Mitglieder keine Mail dabei erhalten!', 3)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','lock_bank_package','Angebotspaket ent-/sperren','Nehmen Sie Angebotspakete zur tempor&auml;ren &Uuml;berarbeitung zuvor heraus, dann k&ouml;nnen Sie in Ruhe dr&uuml;ber nachdenken und Berechnungen anstellen. Freigabe ist hier auch m&ouml;glich.', 4)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','del_bank_package','Angebotspaket l&ouml;schen','Nach Auswahl eines Angebotspaketes k&ouml;nnen Sie mit abschliessender Best&auml;tigung Angebotspakete ganz l&ouml;schen. Bitte beachten Sie, dass dies nur m&ouml;glich ist, wenn auch alle Accounts dieses nicht mehr nutzen!', 5)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','add_bank_account','Konto anlegen','Legen Sie hier Konten f&uuml;r die Mitglieder an (falls Ihre Mitglieder nicht zurecht kommen).', 6)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','list_bank_account','Konten auflisten','Auflistung aller Konto oder eines ausw&auuml;hlbaren Mitglieds.', 7)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','edit_bank_account','Konto &auml;ndern','&Auml;ndern Sie hier bestehende Konten, z.B. den Dispositionskredit usw. PINs und TANs sind hier nicht &auml;nderbar! Best&auml;tigungsmails sind optional versendbar.', 8)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','lock_bank_account','Konto ent-/sperren','Sperren Sie hier Konten bei Bedarf. Auch das Freischalten ist hier m&ouml;glich. Eine Benachrichtigung per Mail wird dann an das Mitglied ausgesendet.', 9)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','del_bank_account','Konto l&ouml;schen','L&ouml;schen von Konten mit Best&auml;tigungsmail. Wenn Sie ein Mitglieder-Account l&ouml;schen, so m&uuml;ssen Sie derzeit seine angelegten Konten auch l&ouml;schen!', 10)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','send_bank_tanlist','TAN-Liste aussenden','Listet zuerst Anfragen von Mitgliedern auf, die eine neue (i)TAN-Liste ben&ouml;tigen, anschliessend kann die Liste dann ausgesendet werden.', 11)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','lock_bank_tanlist','TAN-Liste ent-/sperren','Bestehende TAN-Listen k&ouml;nnen auf Kundenwunsch hin gesperrt und wieder entsperrt werden. Dies passiert auch, wenn der Kunde x-mal (siehe Angebotspakete) eine verkehrte TAN eingegeben hat. Einzelne TANs sind nicht ent-/sperrbar.', 12)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_admin_menu (`action`,`what`,`title`,`descr`,`sort`) VALUES ('bank','list_bank_trans','&Uuml;berweisungen auflisten','Nach Auswahl eines Mitgliedes und einem Konto (ben&ouml;tgt JavaScript!) k&ouml;nnen Sie seitenweise die &Uuml;berweisungen durchschauen.', 13)";

	// Member menu
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank', NULL, 'Bank-Account','N','Y', 3)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_infos','Angebotspakete','N','Y', 1)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_create','Konto anlegen','N','Y', 2)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_deposit','Einzahlen','N','Y', 3)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_withdraw','Auszahlen','N','Y', 4)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_output','Kontoauszug','N','Y', 5)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_change','Paket wechseln','N','Y', 6)";
	$SQLs[] = "INSERT INTO "._MYSQL_PREFIX."_member_menu (`action`,`what`,`title`,`visible`,`locked`,`sort`) VALUES ('bank','bank_remove','K&uuml;ndigen','N','Y', 7)";
	break;

case "remove": // Do stuff when removing extension
	// SQL commands to run
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_accounts";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_transfers";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_packages";
	$SQLs[] = "DROP TABLE IF EXISTS "._MYSQL_PREFIX."_bank_tanlist";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_admin_menu WHERE action='bank' LIMIT 14";
	$SQLs[] = "DELETE LOW_PRIORITY FROM "._MYSQL_PREFIX."_member_menu WHERE action='bank' LIMIT 8";
	break;

case "activate": // Do stuff when admin activates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='Y', locked='N' WHERE action='bank' LIMIT 8";
	break;

case "deactivate": // Do stuff when admin deactivates this extension
	// SQL commands to run
	$SQLs[] = "UPDATE "._MYSQL_PREFIX."_member_menu SET visible='N', locked='Y' WHERE action='bank' LIMIT 8";
	break;

case "update": // Update an extension
	switch ($EXT_VER)
	{
	case "0.0.1": // SQL queries for v0.0.1
		$SQLs[] = "";

		// Update notes (these will be set as task text!)
		$UPDATE_NOTES = "";
		break;
	}
	break;

default: // Do stuff when extension is loaded
	break;
}

// Language file prefix
$EXT_LANG_PREFIX = "bank";

// Extension is always active?
$EXT_ALWAYS_ACTIVE = "N";

//
?>
