<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 01/29/2006 *
 * ================                             Last change: 01/29/2006 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-config_cache.php                            *
 * -------------------------------------------------------------------- *
 * Short description : Configuration for the caching system             *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Konfiguration des Caching-Systems                *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

if (isset($_POST['ok']))
{
	// Cache path has been not changed by default so don't test it again
	$_POST['cache_tested'] = "N";

	// Check if path has been changed
	if ($_POST['cache_path'] != $_CONFIG['cache_path'])
	{
		// Okay, cache path has been altered so we have to test it again!
		$_POST['cache_tested'] = "Y";
	}

	// Delete deactivated cache files
	if (($_POST['cache_admins'] == "N") && ($cacheInstance->cache_file("admins", true)))
	{
		$cacheInstance->cache_destroy();
	}
	if (($_POST['cache_acls'] == "N") && ($cacheInstance->cache_file("acls", true)))
	{
		$cacheInstance->cache_destroy();
	}
	if (($_POST['cache_exts'] == "N") && ($cacheInstance->cache_file("extensions", true)))
	{
		$cacheInstance->cache_destroy();
	}
	if (($_POST['cache_config'] == "N") && ($cacheInstance->cache_file("config", true)))
	{
		$cacheInstance->cache_destroy();
	}
	if (($_POST['cache_modreg'] == "N") && ($cacheInstance->cache_file("modreg", true)))
	{
		$cacheInstance->cache_destroy();
	}
	if (($_POST['cache_refdepth'] == "N") && ($cacheInstance->cache_file("refdepth", true)))
	{
		$cacheInstance->cache_destroy();
	}
	if (($_POST['cache_refsys'] == "N") && ($cacheInstance->cache_file("refsys", true)))
	{
		$cacheInstance->cache_destroy();
	}

	// Save configuration
	ADMIN_SAVE_SETTINGS($_POST);
}
 else
{
	// Prepare data
	switch ($_CONFIG['cache_admins']) {
		case 'Y': define('__ADMINS_Y', " checked"); define('__ADMINS_N', "");         break;
		case 'N': define('__ADMINS_Y', "");         define('__ADMINS_N', " checked"); break;
	}
	switch ($_CONFIG['cache_acls']) {
		case 'Y': define('__ACLS_Y', " checked"); define('__ACLS_N', "");         break;
		case 'N': define('__ACLS_Y', "");         define('__ACLS_N', " checked"); break;
	}
	switch ($_CONFIG['cache_exts']) {
		case 'Y': define('__EXTS_Y', " checked"); define('__EXTS_N', "");         break;
		case 'N': define('__EXTS_Y', "");         define('__EXTS_N', " checked"); break;
	}
	switch ($_CONFIG['cache_config']) {
		case 'Y': define('__CONFIG_Y', " checked"); define('__CONFIG_N', "");         break;
		case 'N': define('__CONFIG_Y', "");         define('__CONFIG_N', " checked"); break;
	}
	switch ($_CONFIG['cache_modreg']) {
		case 'Y': define('__MODREG_Y', " checked"); define('__MODREG_N', "");         break;
		case 'N': define('__MODREG_Y', "");         define('__MODREG_N', " checked"); break;
	}
	switch ($_CONFIG['cache_refdepth']) {
		case 'Y': define('__REFDEPTH_Y', " checked"); define('__REFDEPTH_N', "");         break;
		case 'N': define('__REFDEPTH_Y', "");         define('__REFDEPTH_N', " checked"); break;
	}
	switch ($_CONFIG['cache_refsys']) {
		case 'Y': define('__REFSYS_Y', " checked"); define('__REFSYS_N', "");         break;
		case 'N': define('__REFSYS_Y', "");         define('__REFSYS_N', " checked"); break;
	}
	switch ($_CONFIG['cache_themes']) {
		case 'Y': define('__THEMES_Y', " checked"); define('__THEMES_N', "");         break;
		case 'N': define('__THEMES_Y', "");         define('__THEMES_N', " checked"); break;
	}
	switch ($_CONFIG['cache_admin_menu']) {
		case 'Y': define('__ADMIN_MENU_Y', " checked"); define('__ADMIN_MENU_N', "");         break;
		case 'N': define('__ADMIN_MENU_Y', "");         define('__ADMIN_MENU_N', " checked"); break;
	}
	define('__PATH', $_CONFIG['cache_path']);

	// Load template
	LOAD_TEMPLATE("admin_config_cache");
}
//
?>
