<?php
/************************************************************************
 * MXChange v0.2.1                                    Start: 09/28/2003 *
 * ===============                              Last change: 10/29/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-email_details.php                           *
 * -------------------------------------------------------------------- *
 * Short description : See all email details of ordered mails           *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle Details einer gebuchten Mail ansehen        *
 * -------------------------------------------------------------------- *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2008 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 * -------------------------------------------------------------------- *
 *           Moded What-email_details.php   / also Editet !             *
 * Auf langsammen Servern (wie mein z.B Dauert das Laden)               *
 * enorm hoch zu lang. Jetzt werden nur auftraege aufgelistet die       *
 * NEU sind ( DB NEW) oder ADMIN freischalten muss (DB ADMIN )          *
 * oder noch als TEMP gespecihert sind                                  *
 * der rest der schon als SEND sich melden darf wird per                *
 * what-email_archiv .php aufgerufen                                    *
 * beste gruesse Robert Niedziela / www.personal-webserver.de           *
 * oder auch www.mc-p.org                                               *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!IS_ADMIN())) {
	$INC = substr(dirname(__FILE__), 0, strpos(dirname(__FILE__), "/inc") + 4) . "/security.php";
	require($INC);
}

// Add description as navigation point
ADD_DESCR("admin", basename(__FILE__));

// Normal mails ordered by your members
//              0     1       2       3       4           5          6          7       8        9          10
$SQL = "SELECT id, sender, subject, text, receivers, payment_id, data_type, timestamp, url, target_send, cat_id
FROM "._MYSQL_PREFIX."_pool
WHERE data_type IN('ADMIN','TEMP','NEW','ACTIVE')
ORDER BY timestamp DESC";

$WHO = _ALL;
$SQL2 = "";

if (!empty($_GET['mid']))
{
	// Only a specific mail shall be displayed
	//              0     1       2       3       4           5          6          7       8        9          10
	$SQL = "SELECT id, sender, subject, text, receivers, payment_id, data_type, timestamp, url, target_send, cat_id
	 FROM "._MYSQL_PREFIX."_pool
	 WHERE id='".bigintval($_GET['mid'])."'
	 LIMIT 1";
	$WHO = MAIL_ID.": ".$_GET['mid'];
}
 elseif (!empty($_GET['u_id']))
{
	// All mails by a specific member shall be displayed
	//              0     1       2       3       4           5          6          7       8        9          10
	$SQL = "SELECT id, sender, subject, text, receivers, payment_id, data_type, timestamp, url, target_send, cat_id
	 FROM "._MYSQL_PREFIX."_pool
	 WHERE sender='".bigintval($_GET['u_id'])."'
	 ORDER by timestamp DESC";
	$WHO = USER_ID.": ".$_GET['u_id'];
}

if ((EXT_IS_ACTIVE("bonus")) && ($WHO == _ALL)) {
	// Bonus mails sent by you
	//               0     1       2        3        4      5       6          7       8      9         10          11        12
	$SQL2 = "SELECT id, subject, text, receivers, points, time, data_type, timestamp, url, cat_id, target_send, mails_sent, clicks
	 FROM "._MYSQL_PREFIX."_bonus
	 ORDER BY timestamp DESC";

	// Check for maximum pages
	$result_bonus = SQL_QUERY($SQL2, __FILE__, __LINE__);
}

// Check for maximum pages
$result_normal = SQL_QUERY($SQL, __FILE__, __LINE__);

// Set offset an current page to default values
if (empty($_GET['page']))   $_GET['page']   = "1";
if (empty($_GET['offset'])) $_GET['offset'] = $_CONFIG['mails_page'];

// Add limitation to SQL string
if (empty($_GET['mid']))
{
	// Create limitation line
	$ADD = " LIMIT ".(bigintval($_GET['offset']) * bigintval($_GET['page']) - bigintval($_GET['offset'])).", ".bigintval($_GET['offset']);

	// For normal mails
	$SQL .= $ADD;

	// For bonus mails
	if (!empty($SQL2)) $SQL2 .= $ADD;
}

// Run SQL query for normal mails
$result_list = SQL_QUERY($SQL, __FILE__, __LINE__);
if ((!empty($SQL2)) && ($WHO == _ALL)) $result_bonus = SQL_QUERY($SQL2, __FILE__, __LINE__);

// Calculate pages
$PAGES = round(SQL_NUMROWS($result_normal) / $_CONFIG['mails_page'] + 0.3);
SQL_FREERESULT($result_normal);

$MAIL = false;
if (SQL_NUMROWS($result_list) > 0) {
	// Init rows
	$OUT = ""; $content = array();

	// Walk through all entries
	while ($pool = SQL_FETCHARRAY($result_list)) {
		// Unconfirmed mails and sent mails
		$result_uncon = SQL_QUERY_ESC("SELECT max_rec, clicks FROM "._MYSQL_PREFIX."_user_stats WHERE pool_id=%s LIMIT 1",
		 array(bigintval($pool['id'])), __FILE__, __LINE__);
		list($pool['sent_email'], $pool['clicks']) = SQL_FETCHROW($result_uncon);
		SQL_FREERESULT($result_uncon);

		// Unconfirmed mails
		$pool['unconfirmed'] = $pool['sent_email'] - $pool['clicks'];
		if ($pool['unconfirmed'] > 0) {
			// Add link to list_unconfirmed what-file
			$pool['unconfirmed'] = "<STRONG><A href=\"".URL."/modules.php?module=admin&amp;what=list_unconfirmed&amp;mid=".$pool['id']."\">".$pool['unconfirmed']."</A></STRONG>";
		} elseif ($pool['unconfirmed'] < 0) {
			// Sometimes rarely displayed minus values will be "fixed" to zero
			$pool['unconfirmed'] = 0;
		}

		// Prepare content
		$content = $pool;
		$content['sender_link'] = ADMIN_USER_PROFILE_LINK($pool['sender']);
		$content['subject']     = COMPILE_CODE($pool['subject']);
		$content['text']        = COMPILE_CODE($pool['text']);
		$content['payment']     = GET_PAYMENT($pool['payment_id']);
		$content['category']    = GET_CATEGORY($pool['cat_id']);
		$content['receivers']   = str_replace(";", ", ", $pool['receivers']);
		$content['type']        = TRANSLATE_POOL_TYPE($pool['data_type']);
		$content['frametester'] = FRAMETESTER($pool['url']);
		$content['timestamp']   = MAKE_DATETIME($pool['timestamp'], "0");

		// Load row template
		$OUT .= LOAD_TEMPLATE("admin_list_emails_row", true, $content);
	} // END - while

	// Free memory
	SQL_FREERESULT($result_list);

	// Add navigation (with change box and colspan=3)
	$content['nav'] = "";
	if ($PAGES > 1) $content['nav'] = ADD_EMAIL_NAV($PAGES, $_CONFIG['mails_page'], false, "3", true);

	// Prepare content
	$content['rows'] = $OUT;
	$content['who'] = $WHO;

	// Mail orders are in pool so we can display them
	LOAD_TEMPLATE("admin_list_emails", false, $content);

	$MAIL = true;
	if ((EXT_IS_ACTIVE("bonus")) && ($WHO == _ALL)) {
		// Check only if bonus extension is active
		if (SQL_NUMROWS($result_bonus) > 0) OUTPUT_HTML("<br /><br />");
	}
}

if ((EXT_IS_ACTIVE("bonus")) && ($WHO == _ALL)) {
	// Load bonus mails only when extension is active
	if (SQL_NUMROWS($result_bonus) > 0) {
		// Calculate pages
		$PAGES = round(SQL_NUMROWS($result_bonus) / $_CONFIG['mails_page'] + 0.5);

		// List emails
		$OUT = ""; $content = array();
		while ($bonus = SQL_FETCHARRAY($result_bonus)) {
			// Calculate unconfirmed emails
			$bonus['unconfirmed'] = $bonus['mails_sent'] - $bonus['clicks'];

			// Add link?
			if ($bonus['unconfirmed'] > 0) {
				// Add link to list_unconfirmed what-file
				$bonus['unconfirmed'] = "<STRONG><A href=\"".URL."/modules.php?module=admin&amp;what=list_unconfirmed&amp;bid=".$bonus['id']."\">".$bonus['unconfirmed']."</A></STRONG>";
			} // END - if

			// Prepare content
			$content = $bonus;
			$content['time']        = CREATE_FANCY_TIME($content['time']);
			$content['category']    = GET_CATEGORY($content['cat_id']);
			$content['receivers']   = str_replace(";", ", ", $content['receivers']);
			$content['type']        = TRANSLATE_POOL_TYPE($content['data_type']);
			$content['frametester'] = FRAMETESTER($content['url']);
			$content['timestamp']   = MAKE_DATETIME($content['timestamp'], "0");

			// Load row template
			$OUT .= LOAD_TEMPLATE("admin_list_bonus_emails_row", true, $content);
		}

		// Add navigation (without change box but with colspan=3)
		$content['nav'] = "";
		if ($PAGES > 1) $content['nav'] = ADD_EMAIL_NAV($PAGES, $_CONFIG['mails_page'], false, "3", true);

		// Prepare content
		$content['rows'] = $OUT;

		// Load main template
		LOAD_TEMPLATE("admin_list_bonus_emails", false, $content);
		$MAIL = true;
	}
}

if (!$MAIL) {
	// No mail orders fond
	OUTPUT_HTML("<SPAN class=\"admin_failed\">".ADMIN_NO_MAILS_IN_POOL."</SPAN>");
}

//
?>
